#!/usr/bin/ruby -Ks
#
#  YKLook
#        Copyright (C) 2009-2010 YorozuKotowariYa Ltd.


if ARGV.size() != 1
	STDERR.puts("need a filename")
	exit
end

YK_TITLE = "Java NXΉ\"

def mTrimBlank( prmSource )
	idx = 0
	while idx < prmSource.size()
		if prmSource[idx] != 0x20 and prmSource[idx] != 0x09 and
			prmSource[idx] != 0x0d and prmSource[idx] != 0x0a
			if prmSource[idx] != 0x81
				break
			end
			if (idx + 1) >= prmSource.size()
				STDERR.puts("ill-kanji")
				STDERR.puts("str=(" + prmSource + ')')
				raise
			end
			if prmSource[idx+1] != 0x40
				break
			end
			idx += 1
		end
		idx += 1
	end
	if idx >= prmSource.size()
		return ''
	end
	j = prmSource.size() - 1
	while j >= 0
		if prmSource[j] != 0x20 and prmSource[j] != 0x09 and
			prmSource[j] != 0x0d and prmSource[j] != 0x0a
			if j < 1
				break
			end
			if prmSource[j-1] != 0x81 or prmSource[j] != 0x40
				break
			end
			j -= 1
		end
		j -= 1
	end
	if j < 0
		STDERR.puts('error fatal')
		exit
	end
	return prmSource[idx..j]
end
def mEscapeHtml( prmSource )
	msg = prmSource.gsub( '&' , '&amp;'     )
	tmp =       msg.gsub( '<' , '&lt;'      )
	return      tmp.gsub( '>' , '&gt;'      )
	# return      wrk.gsub( "\n", "<br />\n"  )
end
def mPutHeader()
	print <<"EOF"
<html lang=ja>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=shift_jis">
<title> YKLook  t^FRuby ̑킩 </title>
<style type="text/css">
<!--  
.yk-leftmargin  { margin-left: 30px }
  -->
</style>
</head>




<!--  
                    ێS҂ւ̓`

                    ̃t@C𒼐ڕҏW_I@ij
  -->





<body bgcolor="#ffffff">
<table width="100%" border=0 cellpadding=0 cellspacing=0>
  <tr>
    <td>
      <a href="../index.html"> YKLook </a> 
      <a name="top"> t^FRuby ̑킩 </a>
    </td>
    <td align=right>
      <a href="../man-class/cla-list-xref.html" title="#{YK_TITLE}"> O </a>
      <!-- kanji sp --> @ <!-- kanji sp -->
      
    </td>
  </tr>
</table>
EOF
end
def mPutLinkBar()
	print <<"EOF"
<table bgcolor="#ccffcc" width="100%" border=0 cellpadding=0 cellspacing=0>
  <tr nowrap>
    <td>
      <!-- kanji sp --> @ <!-- kanji sp -->
    </td>
    <td> &nbsp; </td>
  </tr>
</table>
EOF
end
def mPutFooter()
	print <<"EOF"
<table width="100%" border=0 cellpadding=0 cellspacing=0>
  <tr>
    <td>
      <a href="../index.html"> YKLook </a> 
      <a href="#top" title="̃y[W̐擪"> t^FRuby ̑킩 </a>
    </td>
    <td align=right>
      <a href="../man-class/cla-list-xref.html" title="#{YK_TITLE}"> O </a>
      <!-- kanji sp --> @ <!-- kanji sp -->
      
    </td>
  </tr>
</table>
<br>
<hr>
<center>
  <span title="iLj낸Ƃ">
    Copyright (c) 2003-2010 YorozuKotowariYa Ltd.
  </span>
</center>

<!-- 

Copyright (c) 2003-2010 YorozuKotowariYa Ltd.
iLj낸Ƃ

designed by Hatashima Koji
written by Hatashima Koji
݌vF_
F_

 -->

</body>
</html>
EOF
end
def mPutSubTitle( prmLinkLabel, prmDisplayLabel )
	print <<"EOF"
<br />
<table bgcolor="#dddddd" width="100%" cellpadding=4>
<tr><td id="#{prmLinkLabel}"> #{prmDisplayLabel} </td></tr>
</table>
<br />
EOF
end
def mMakeInfo( prmLines )
	inf = []
	ary = []
	subary = []
	prmLines.each_with_index() do |buf,idx|
		if buf == "ȏ\n"
			break
		end
		if /^ruby-toc.txt / =~ buf
			next
		end
		if buf.size() > 1
			if /^[^@]/ =~ buf
				ary = [ mTrimBlank( buf ) ]
				inf << ary
			else
				if /^@@/ =~ buf
					if /^@@[^@]/ =~ buf
						subary = [ mTrimBlank( buf ) ]
						ary << subary
					else
						subary << buf
					end
				end
			end
		end
	end
	# inf[0..n][0] = title
	# inf[0..n][1..n][0] = subtitle
	# inf[0..n][1..n][1..n] = raw text
	return inf
end
def mPutDai( prmInfo )
	mPutSubTitle( 'dai', '區ڂ̂' )
	puts('<div class="yk-leftmargin">')
	puts('<ul>')
	prmInfo.each_with_index() do |daiVal,daiIdx|
		ref = "dai-#{daiIdx+1}"
		dsp = mEscapeHtml( daiVal[0] )
		puts( '  <li> <a href="#' + ref + '">' + dsp + '</a>' )
	end
	puts('</ul>')
	puts('</div>')
	puts('<br />')
end
def mPutChu( prmInfo )
	mPutSubTitle( 'chu', 'ڂ܂' )
	puts('<div class="yk-leftmargin">')
	puts('<ul>')
	prmInfo.each_with_index() do |daiVal,daiIdx|
		ref = "dai-#{daiIdx+1}"
		dsp = mEscapeHtml( daiVal[0] )
		puts( '  <li> <a href="#' + ref + '">' + dsp + '</a>' )
		puts( '    <ul>' )
		daiVal[1..-1].each_with_index() do |chuVal,chuIdx|
			ref = "chu-#{daiIdx+1}-#{chuIdx+1}"
			dsp = mEscapeHtml( chuVal[0] )
			puts( '      <li> <a href="#' + ref + '">' + dsp + '</a>' )
		end
		puts('    </ul>')
	end
	puts('</ul>')
	puts('</div>')
	puts('<br />')
end
def mPutSho( prmInfo )
	prmInfo.each_with_index() do |daiVal,daiIdx|
		ref = "dai-#{daiIdx+1}"
		dsp = mEscapeHtml( daiVal[0] )
		mPutSubTitle( ref, dsp )
		daiVal[1..-1].each_with_index() do |chuVal,chuIdx|
			ref = "chu-#{daiIdx+1}-#{chuIdx+1}"
			dsp = mEscapeHtml( chuVal[0] )
			puts( '<a name="' + ref + '">' + dsp + '</a> <br />' )
			puts( '<pre>' )
			chuVal[1..-1].each() do |shoVal|
				puts( mEscapeHtml( shoVal ) )
			end
			puts( '</pre>' )
			puts( '<br />')
		end
		puts('<br />')
	end
end


#
# main
#
lines = File.readlines( ARGV[0] )
info  = mMakeInfo( lines )
mPutHeader()
mPutLinkBar()
print <<"EOF"
<br>
<h1> t^FRuby ̑킩 </h1>
<br>
<ul>
  <li> <a href="#dai"> 區ڂ̂ </a>
  <li> <a href="#chu"> ڂ܂ </a>
</ul>
<br>
EOF
mPutDai( info )
puts('<br>')
mPutChu( info )
puts('<br> <br>')
mPutSho( info )
puts('<br> <br>')
mPutLinkBar()
mPutFooter()

#
# end
