//
//  How to Compile...   javac YKShowFontList.java
//  How to Execute...   java  YKShowFontList
//
//
//  YKShowFontList
//
//  Copyright (c) 2003-2010 YorozuKotowariYa Ltd.
//
import java.util.*;
import java.text.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.GraphicsEnvironment;

public class YKShowFontList extends JFrame implements ActionListener
{
	static final String[] styleStrings = { "PLAIN", "BOLD", "ITALIC", "B + I" };
	static final int   [] styleNumbers = { Font.PLAIN, Font.BOLD, Font.ITALIC,
											Font.BOLD + Font.ITALIC };

	static final String doClickMessage = // list naino font wo sentaku sitekdsi
							"\u30ea\u30b9\u30c8\u5185\u306e" +
							"\u30d5\u30a9\u30f3\u30c8\u3092" +
							"\u9078\u629e\u3057\u3066\u304f\u3060\u3055\u3044";
	static final String doInputMessage = // tekiseina size wo nyuuryoku sitekdsi
							"\u9069\u6b63\u306a\u30b5\u30a4\u30ba\u3092" +
							"\u5165\u529b\u3057\u3066\u304f\u3060\u3055\u3044";
	static final String tooltipCbxStyle = // style: tujo futoji naname ryoho
							"\u30b9\u30bf\u30a4\u30eb\uff1a"       +
							"\u901a\u5e38\u30fb\u592a\u5b57\u30fb" +
							"\u659c\u3081\u30fb\u4e21\u65b9";
	static final String tooltipTfSize = // point size
							"\u30dd\u30a4\u30f3\u30c8\u30b5\u30a4\u30ba";
	static final String tooltipBtnShow = // textArea no font wo henkou simasu
							"\u30c6\u30ad\u30b9\u30c8\u30a8\u30ea\u30a2\u306e" +
							"\u30d5\u30a9\u30f3\u30c8\u3092" +
							"\u5909\u66f4\u3057\u307e\u3059";
	static final String tooltipBtnXfer = // font mei wo textArea ni tuika simasu
							"\u30d5\u30a9\u30f3\u30c8\u540d\u3092"       +
							"\u30c6\u30ad\u30b9\u30c8\u30a8\u30ea\u30a2" +
							"\u306b\u8ffd\u52a0\u3057\u307e\u3059";
	static final String tooltipBtnInfo = // font jouhou wo hyouji simasu
							"\u30d5\u30a9\u30f3\u30c8\u60c5\u5831" +
							"\u3092\u8868\u793a\u3057\u307e\u3059";

	String[]   fontNames;
	JList      lisFont;
	JComboBox  cbxStyle;
	JTextField tfSize;
	JTextArea  taLook;
	JButton    btnShow;
	JButton    btnXfer;
	JButton    btnInfo;

	void mMakeDisplay( boolean prmShowAll )
	{
		JPanel    center    = new JPanel();
		JPanel    control   = new JPanel();
		Container cPane     = getContentPane();
		String[]  listItems = mCheckFontList( prmShowAll );

		lisFont   = new JList( listItems );
		cbxStyle  = new JComboBox( styleStrings );
		tfSize    = new JTextField( "12", 5 );
		taLook    = new JTextArea( "123.ABC-_/");
		btnShow   = new JButton( "show" );
		btnXfer   = new JButton( "xfer" );
		btnInfo   = new JButton( "info" );

		btnShow.setAlignmentX( 0.5f );
		btnXfer.setAlignmentX( 0.5f );
		btnInfo.setAlignmentX( 0.5f );

		cbxStyle.setToolTipText( tooltipCbxStyle );
		tfSize  .setToolTipText( tooltipTfSize   );
		btnShow .setToolTipText( tooltipBtnShow  );
		btnXfer .setToolTipText( tooltipBtnXfer  );
		btnInfo .setToolTipText( tooltipBtnInfo  );

		taLook.setPreferredSize( new Dimension( 300, 200 ) );
		taLook.setLineWrap( true );
		control.setLayout( new BoxLayout( control, BoxLayout.Y_AXIS ) );

		center.add( new JScrollPane( lisFont ) );
		control.add( cbxStyle );
		control.add( tfSize );
		control.add( Box.createRigidArea( new Dimension( 0, 10 ) ) );
		control.add( btnShow );
		control.add( Box.createRigidArea( new Dimension( 0, 10 ) ) );
		control.add( btnXfer );
		control.add( Box.createRigidArea( new Dimension( 0, 10 ) ) );
		control.add( btnInfo );
		center.add( control );
		center.add( taLook );
		cPane.add( center, "Center" );

		btnShow.addActionListener( this );
		btnXfer.addActionListener( this );
		btnInfo.addActionListener( this );
	}
	String[] mCheckFontList( boolean prmShowAll )
	{
		GraphicsEnvironment ge;
		Font  [] fonts;
		String[] listItems;
		String   name;
		String   face;
		int      idx;
		int      cnt;

		ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
		fonts = ge.getAllFonts();
		
		if( prmShowAll )
		{
			cnt = fonts.length;
		}
		else
		{
			cnt = 0;
			for( idx = 0; idx < fonts.length; idx++ )
			{
				if( fonts[idx].getName().charAt(0) >= 0x41 )
					cnt++;
			}
		}
		fontNames = new String[ cnt ];
		listItems = new String[ cnt ];

		cnt = 0;
		for( idx = 0; idx < fonts.length; idx++ )
		{
			name = fonts[idx].getName();
			if( prmShowAll || (name.charAt(0) >= 0x41) )
			{
				fontNames[cnt] = name;
				face = fonts[idx].getFontName();
				if( ! face.equals( name ) )
					name = name + " (" + face + ")";

				listItems[cnt] = name;
				cnt++;
			}
		}
		return listItems;
	}
	public void actionPerformed( ActionEvent prmEvent )
	{
		int      idxFont  = lisFont.getSelectedIndex();
		int      idxStyle = cbxStyle.getSelectedIndex();
		int      size     = mGetInt( tfSize.getText(), 0, 1000 );
		Font     font;

		if( idxFont < 0 || fontNames.length <= idxFont )
		{
			JOptionPane.showMessageDialog( null, doClickMessage );
			return;
		}
		if( size == Integer.MAX_VALUE || size == Integer.MIN_VALUE )  // error ?
		{
			JOptionPane.showMessageDialog( null, doInputMessage );
			return;
		}
		font = new Font( fontNames[idxFont], styleNumbers[idxStyle], size );

		if( prmEvent.getSource() == btnShow )
		{
			taLook.setFont( font );
		}
		if( prmEvent.getSource() == btnXfer )
		{
			mXferInfo( font, styleStrings[idxStyle], size );
		}
		if( prmEvent.getSource() == btnInfo )
		{
			mShowInfo( font );
		}
	}
	int mGetInt( String prmText, int prmMin, int prmMax )
	{
		int val;

		try
		{
			val = Integer.parseInt( prmText );
			if( val < prmMin || prmMax < val )
				val = Integer.MAX_VALUE;        // as error number
		}
		catch( Exception ex )
		{
			val = Integer.MIN_VALUE;            // as error number
		}
		return val;
	}
	void mXferInfo( Font prmFont, String prmStyle, int prmSize )
	{
		taLook.append(  "\nfamily: "  + prmFont.getFamily()   +
						"\nface: "    + prmFont.getFontName() +
						"\nlogical: " + prmFont.getName()     +
						"\nstyle: "   + prmStyle              +
						"\nsize: "    + prmSize );
	}
	void mShowInfo( Font prmFont )
	{
		AttributedCharacterIterator.
		Attribute[]  chratt = prmFont.getAvailableAttributes();
		String       family = prmFont.getFamily();
		String       face   = prmFont.getFontName();
		String       lgn    = prmFont.getName();
		String       psname = prmFont.getPSName();
		int          style  = prmFont.getStyle();
		int          size   = prmFont.getSize();
		float        size2d = prmFont.getSize2D();
		float        angle  = prmFont.getItalicAngle();
		Map          attr   = prmFont.getAttributes();
		int          miscod = prmFont.getMissingGlyphCode();
		int          num    = prmFont.getNumGlyphs();
		boolean      hulm   = prmFont.hasUniformLineMetrics();
		boolean      bold   = prmFont.isBold();
		boolean      italic = prmFont.isItalic();
		boolean      plain  = prmFont.isPlain();
		String[]     msg    = new String[ 8 + attr.size() + chratt.length ];
		Iterator     itr    = attr.keySet().iterator();
		Object       key;
		Object       val;
		int          idx;

		msg[0] = " familyName: " + family;
		msg[1] = "   faceName: " + face;
		msg[2] = "logicalName: " + lgn;
		msg[3] = "     PSName: " + psname;
		msg[4] = "      style: " + style + " (" + mStyle( style ) + ")";
		msg[5] = "       size: " + size + " (" + size2d + ")";
		msg[6] = "italicAngle: " + angle +
				"     missingGlyphCode: " + miscod +
				"     numberOfGlyphs: " + num;
		msg[7] = " hasUniformLineMetrics: " + hulm +
				"     isBold: "   + bold   +
				"     isItalic: " + italic +
				"     isPlain: "  + plain;
		idx = 0;
		while( itr.hasNext() )
		{
			key = itr.next();
			val = attr.get( key );
			msg[8 + idx] = "attr[" + key + "]=(" + val + ")";
			idx++;
		}
		for( idx = 0; idx < chratt.length; idx++ )
		{
			msg[8 + attr.size() + idx] =
				"AvailableAttr[" + idx + "]=("+ chratt[idx].toString() + ")";
		}
		JOptionPane.showMessageDialog( null, msg );
	}
	String mStyle( int prmStyle )
	{
		int idx;

		for( idx = 0; idx < styleNumbers.length; idx++ )
		{
			if( styleNumbers[idx] == prmStyle )
				if( idx < styleStrings.length )
					return styleStrings[idx];
		}
		return "unknown";
	}

	public static void main( String[] args )
	{
		String         fontName    = null;
		String         lookAndFeel = null;
		boolean        flagShowAll = false;
		boolean        flagFamily  = false;
		YKShowFontList windowFrame = new YKShowFontList();
		int            idx;
		char           arg;

		for( idx = 0; idx < args.length; idx++ )
		{
			arg = args[idx].toLowerCase().charAt(0);
			if( arg == 'c' )
				lookAndFeel = UIManager.getCrossPlatformLookAndFeelClassName();
			if( arg == 's' )
				lookAndFeel = UIManager.getSystemLookAndFeelClassName();
			if( arg == 'a' )
				flagShowAll = true;
			if( arg == 'f' )
				flagFamily = true;
			if( arg == 'd' )
			{
				if( args[idx].length() > 2 )
				{
					if( args[idx].charAt(1) == '=' )
						fontName = args[idx].substring( 2 );
				}
				mDefaultFont( fontName );
				System.exit(0);
			}
		}
		if( flagFamily )
		{
			mFamilyName( flagShowAll );
			System.exit(0);
		}
		if( lookAndFeel != null )
		{
			try
			{
				UIManager.setLookAndFeel( lookAndFeel );
				SwingUtilities.updateComponentTreeUI(
												windowFrame.getContentPane() );
			}
			catch( Exception ex )
			{
				ex.printStackTrace();
			}
		}
		windowFrame.mMakeDisplay( flagShowAll );
		windowFrame.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
		windowFrame.setResizable( false );
		windowFrame.setTitle( "YKShowFontList" );
		windowFrame.setSize( 800, 600 );
		windowFrame.pack();
		windowFrame.show();
	}
	static void mFamilyName( boolean prmShowAll )
	{
		GraphicsEnvironment ge;
		String[]            af;
		int                 idx, cnt;

		ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
		af = ge.getAvailableFontFamilyNames();

		System.out.println("family names..." );

		cnt = 0;
		for( idx = 0; idx < af.length; idx++ )
		{
			if( prmShowAll || (af[idx].charAt(0) >= 0x41) )
			{
				System.out.println( af[idx] );
				cnt++;
			}
		}
		if( cnt == af.length )
			System.out.println("total: " + cnt );
		else
			System.out.println("total: " + cnt + " / " + af.length );
	}
	static void mDefaultFont( String prmName )
	{
		Font f = new Font( prmName, Font.PLAIN, 12 );

		if( prmName == null )
			System.out.println("default font...");
		else
			System.out.println("font(" + prmName + ")...");

		if( f == null )
		{
			System.out.println("error: bad Font.");
		}
		else
		{
			System.out.println("\t family name: " + f.getFamily() );
			System.out.println("\t   face name: " + f.getFontName() );
			System.out.println("\tlogical name: " + f.getName() );
		}
	}
}


//
//  end of program
//
